/* 
 Joan Soler-Adillon
 Realitat Virtual || Realidad Virtual - Processing
 Màster en Arts Digitals, UPF
 http://www.joan.cat/
 */

import oscP5.*;
import netP5.*;

int total = 4000;
attractor[] tractors = new attractor[4];
cosa[] cosasList = new cosa[total];


//declaramos variables
PVector gravedad, wind;

MouTe mt = new MouTe();//Objecte mouTe

void setup() {

  noSmooth();
  size(600, 450);
  //inicializamos variables
  gravedad = new PVector(0, 0.05);
  wind = new PVector(0, 0);
  for (int i=0; i<total; i++) {
    cosasList[i] = new cosa();
  }
  for (int i=0; i<4; i++) {
    tractors[i] = new attractor();
  }
}

void draw() {
  background(0);
  float jumpValue = 5;
  //Position attractors:
  //println(mt.getLeftXBox());
  if (mt.getLeftXBox() != -1) { //si hi ha usuari
    tractors[0].setX(mt.getLeftXBoxRelative()+random(-jumpValue, jumpValue));
    tractors[0].setY(mt.getUpperYBoxRelative()+random(-jumpValue, jumpValue));
    tractors[1].setX(mt.getLeftXBoxRelative()+random(-jumpValue, jumpValue));
    tractors[1].setY(mt.getLowerYBoxRelative()+random(-jumpValue, jumpValue));
    tractors[2].setX(mt.getRightXBoxRelative()+random(-jumpValue, jumpValue));
    tractors[2].setY(mt.getUpperYBoxRelative()+random(-jumpValue, jumpValue));
    tractors[3].setX(mt.getRightXBoxRelative()+random(-jumpValue, jumpValue));
    tractors[3].setY(mt.getLowerYBoxRelative()+random(-jumpValue, jumpValue));

    fill(255, 50);
    noStroke();
    //draw particles:
    for (cosa c : cosasList) {
      for (attractor a : tractors) {
        c.addForce(a.getForce(c.posicion));
      }
      PVector grav = gravedad.get();
      grav.mult(c.myMass);
      c.addForce(grav);
      c.run();
    }
    //Draw attractors
    noFill();
    stroke(255, 0, 0, 120);
    for (attractor a : tractors) {
      ellipse(a.pos.x, a.pos.y, 5, 5);
    }
  } 
  else {
    fill(255, 50);
    noStroke();
    for (cosa c : cosasList) {
      c.run();
    }
  }
}


